import 'core-js/fn/array/find';
import 'core-js/fn/array/find-index';

import Affix from './components/affix';
import AutoComplete from './components/auto-complete';
import Avatar from './components/avatar';
import BackTop from './components/back-top';
import Badge from './components/badge';
import Breadcrumb from './components/breadcrumb';
import Button from './components/button';
import Carousel from './components/carousel';
import Cascader from './components/cascader';
import Checkbox from './components/checkbox';
import DatePicker from './components/date-picker';
import Dropdown from './components/dropdown';
import Form from './components/form';
import Icon from './components/icon';
import Input from './components/input';
import InputNumber from './components/input-number';
import Scroll from './components/scroll';
// import LoadingBar from './components/loading-bar';
import Message from './components/message';
import Modal from './components/modal';
import Page from './components/page';
import Progress from './components/progress';
import Poptip from './components/poptip';
import Radio from './components/radio';
import Rate from './components/rate';
import Spin from './components/spin';
import Steps from './components/steps';
import Tabs from './components/tabs';
import Tag from './components/tag';
import Timeline from './components/timeline';
import TimePicker from './components/time-picker';
import Tooltip from './components/tooltip';
import Upload from './components/upload';
import { Select, Option, OptionGroup } from './components/select';
import locale from './locale/index';


import LazyImg from './components/lazy-img';

import TkProductList from './components/tk-product-list';
import TkFooter from './components/tk-footer';
import TkHeader from './components/tk-header';
import TkHeaderSearch from './components/tk-header-search';
import TkChooseModel from './components/tk-choose-model';
import TkTitle from './components/tk-title';
import TkBigPicture from './components/tk-big-picture';
import TkUploadImage from './components/tk-upload-image';
import TkLogo from './components/tk-logo';
import TkAddress from './components/tk-address';
import TkAddressList from './components/tk-address-list';
import TkInputNumber from './components/tk-input-number';
import TkAddressChoose from './components/tk-address-choose';
import TkTabs from './components/tk-tabs';
import IM from './components/im';
import TkAddressInvoice  from './components/tk-address-invoice';

const components = {
    TkAddressInvoice,
    IM,
    Affix,
    AutoComplete,
    Avatar,
    BackTop,
    Badge,
    Button,
    ButtonGroup: Button.Group,
    Carousel,
    Cascader,
    CarouselItem: Carousel.Item,
    Checkbox,
    CheckboxGroup: Checkbox.Group,
    DatePicker,
    Dropdown,
    DropdownItem: Dropdown.Item,
    DropdownMenu: Dropdown.Menu,
    Form,
    FormItem: Form.Item,
    Icon,
    Input,
    InputNumber,
    Scroll,
    // LoadingBar,
    Message,
    Modal,
    Option: Option,
    OptionGroup,
    Page,
    Poptip,
    Radio,
    RadioGroup: Radio.Group,
    Rate,
    Select,
    Spin,
    Step: Steps.Step,
    Steps,
    Tabs: Tabs,
    TabPane: Tabs.Pane,
    Tag,
    Timeline,
    TimelineItem: Timeline.Item,
    TimePicker,
    Tooltip,
    Upload,
    Breadcrumb,
    BreadcrumbItem: Breadcrumb.Item,
    LazyImg,
    TkProductList,
    TkFooter,
    TkHeader,
    TkHeaderSearch,
    TkChooseModel,
    TkTitle,
    TkBigPicture,
    TkUploadImage,
    TkLogo,
    TkAddress,
    TkAddressList,
    TkInputNumber,
    TkAddressChoose,
    TkTabs,
    TkTabPane: TkTabs.Pane,
};
const itk = {
    ...components,
    iButton: Button,
    iForm: Form,
    iInput: Input,
    iOption: Option,
    iProgress: Progress,
    iSelect: Select
};

const install = function (Vue) {
    if (install.installed) return;

    Object.keys(itk).forEach(key => {
        Vue.component(key, itk[key]);
    });

    // Vue.prototype.$Loading = LoadingBar;
    Vue.prototype.$Message = Message;
    Vue.prototype.$Modal = Modal;
    Vue.prototype.$Spin = Spin;
};

// auto install
if (typeof window !== 'undefined' && window.Vue) {
    install(window.Vue);
}

const API = {
    install,
    locale: locale.use,
    i18n: locale.i18n,
};

API.lang = (code) => {
    const langObject = window['itk/locale'].default;
    if (code === langObject.i.locale) locale.use(langObject);
    else console.log(`The ${code} language pack is not loaded.`); // eslint-disable-line no-console
};

module.exports.default = module.exports = API;
